package com.nisum.mytime.repository;

import java.util.List;
import java.util.Set;

import org.springframework.data.mongodb.repository.MongoRepository;

import com.nisum.mytime.model.Employee;

public interface EmployeeRolesRepo
        extends MongoRepository<Employee, String> {

    Employee findByEmailId(String emailId);

    Employee findByEmployeeId(String employeeId);

    Employee findByEmployeeName(String employeeName);

    List<Employee> findByEmpStatusAndFunctionalGroup(String empStatus,
            String functionalGroup);

    List<Employee> findByEmpStatusOrderByEmployeeNameAsc(String empStatus);
    
    List<Employee> findByEmpStatus(String status);
    
    List<Employee> findByEmployeeIdIn(Set<String> empIdsSet);
}
 